library bv_utilities; use bv_utilities.bv_arithmetic.all;

entity comp_exp is

	generic(E_WIDTH: positive);

	port(	faktor1_exp:	in	bit_vector(E_WIDTH-1 downto 0);
			faktor2_exp:	in	bit_vector(E_WIDTH-1 downto 0);
			norm:			in	bit;
			produkt_exp:	out	bit_vector(E_WIDTH-1 downto 0);
			ov:				out bit);

end entity comp_exp;


architecture behaviour1 of comp_exp is
begin

	process(faktor1_exp, faktor2_exp, norm) is
		constant BIAS:				natural := 2 ** (E_WIDTH-1) - 1;
		variable faktor1_exp_i:	natural;
		variable faktor2_exp_i:		natural;
		variable norm_i:			natural;
		variable produkt_exp_i:	integer;
		variable produkt_exp_full:	bit_vector(E_WIDTH downto 0);
	begin
		-- convert bit_vector to natural
		faktor1_exp_i := bv_to_natural(faktor1_exp);
		faktor2_exp_i := bv_to_natural(faktor2_exp);
		if norm = '1' then norm_i := 1; else norm_i := 0; end if;

		-- actual computation
		produkt_exp_i := faktor1_exp_i + faktor2_exp_i + norm_i - BIAS;
		
		-- convert integer to bit_vector
		produkt_exp_full := integer_to_bv(produkt_exp_i, E_WIDTH+1);		

		-- assign output signals
		produkt_exp <= produkt_exp_full(E_WIDTH-1 downto 0);
		ov <= produkt_exp_full(E_WIDTH);
	end process;
	
end architecture behaviour1;
